<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">
	protected void btnUpdateAddress_Click(object sender, EventArgs e)
	{
		SqlDataAdapter EmpAdapter = new SqlDataAdapter();
		DataTable EmpDT = new DataTable();
		SqlConnection DBConSelect = new SqlConnection();
		SqlConnection DBConUpdate = new SqlConnection();
		SqlCommand SelectCommand = new SqlCommand();
		SqlCommand UpdateCommand = new SqlCommand();

		// Pouit odlinch objekt pipojen k vbru a aktualizaci
		// databze Northwind.
		DBConSelect.ConnectionString =
	ConfigurationManager.ConnectionStrings["DSN_NorthWind"].ConnectionString;
		DBConUpdate.ConnectionString =
	ConfigurationManager.ConnectionStrings["DSN_NorthWind"].ConnectionString;

		// Naten vech zznam z tabulky Employees
		SelectCommand.CommandText = "SELECT top 500 * FROM EMPLOYEES";
		SelectCommand.CommandType = CommandType.Text;
		SelectCommand.Connection = DBConSelect;

		UpdateCommand.CommandText = " UPDATE EMPLOYEES SET Address=@Address, " +
			"City=@City, Region=@Region, Country=@Country";

		UpdateCommand.CommandType = CommandType.Text;
		UpdateCommand.Connection = DBConUpdate;

		SqlParameter AddressParam;
		AddressParam = new SqlParameter("@Address",
			SqlDbType.VarChar, 15, "Address");

		SqlParameter CityParam;
			CityParam = new SqlParameter("@City", SqlDbType.VarChar, 15, "City");

		SqlParameter RegionParam;
		RegionParam = new SqlParameter("@Region", SqlDbType.VarChar, 
			15, "Region");

		SqlParameter CountryParam;
		CountryParam = new SqlParameter("@Country",
			SqlDbType.VarChar, 15, "Country");

		UpdateCommand.Parameters.Add(AddressParam);
		UpdateCommand.Parameters.Add(CityParam);
		UpdateCommand.Parameters.Add(RegionParam);
		UpdateCommand.Parameters.Add(CountryParam);

		// Nastaven pkaz Select a Update v objektu DataAdapter.
		// Pkaz Select se pouije k pevzet daj o vech
		// zamstnancch z databze Northwind a pkaz Update
		// se pouije k uloen zmn zpt do tto databze.
		EmpAdapter.SelectCommand = SelectCommand;
		EmpAdapter.UpdateCommand = UpdateCommand;

		EmpAdapter.Fill(EmpDT);

		DBConSelect.Close();

		// Cyklick prochzen zznamy vech zamstnanc a piazovn
		// novch adres
		foreach (DataRow DR in EmpDT.Rows)
		{
			DR["Address"] = "4445 W 77th Street, Suite 140";
			DR["City"] = "Edina";
			DR["Region"] = "Minnesota";
			DR["Country"] = "USA";
		}

		// Pidn novho handleru udlost naslouchajcho udlosti 
		// RowUpdated.
		// Tato udlost se vyvol po vykonn kad dvky.
		EmpAdapter.RowUpdated += new SqlRowUpdatedEventHandler(OnRowUpdated);

		lblCounter.Text = "";

		EmpAdapter.UpdateBatchSize = 100;

		// Pi dvkovm zpracovn aktualizovanch zznam je dleit 
		// nastavit tuto vlastnost, protoe dvkov aktualizace nemohou
		// aktualizovat zdroj zmnami z databze.
		UpdateCommand.UpdatedRowSource = UpdateRowSource.None;

		try
		{
			DBConUpdate.Open();
			EmpAdapter.Update(EmpDT);
		}
		catch (Exception ex)
		{
			lblCounter.Text += ex.Message + "<Br>";
		}
		finally
		{
			if (DBConUpdate.State == ConnectionState.Open)
			{
				DBConUpdate.Close();
			}
		}
	}

	private void OnRowUpdated(object sender, SqlRowUpdatedEventArgs args)
	{
		lblCounter.Text += "Dvkov se zpracovalo ji " +
			args.RowCount.ToString() + " dk<br>";
	}
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Dvkov zpracovn vce aktualizac</title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<asp:Button ID="btnUpdateAddress" Runat="server" 
			Text="Aktualizovat adresu" OnClick="btnUpdateAddress_Click" />
		<br />
		<br />
		<asp:Label ID="lblCounter" Runat="server"></asp:Label>&nbsp;<br />
		<br />
		<br />
	</div>
	</form>
</body>
</html>
