<%@ Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">
	Sub btnUpdateAddress_Click(ByVal sender As Object, _
		ByVal e As System.EventArgs) Handles btnUpdateAddress.Click

		Dim EmpAdapter As SqlDataAdapter = New SqlDataAdapter()
		Dim EmpDT As DataTable = New DataTable()
		Dim DBConSelect As SqlConnection = New SqlConnection()
		Dim DBConUpdate As SqlConnection = New SqlConnection()
        Dim SelectCommand As SqlCommand = New SqlCommand()
		Dim UpdateCommand As SqlCommand = New SqlCommand()

		' Pouit odlinch objekt pipojen k vbru a aktualizaci
		' databze Northwind.
		DBConSelect.ConnectionString = _
	ConfigurationManager.ConnectionStrings("DSN_NorthWind").ConnectionString
		DBConUpdate.ConnectionString = _
	ConfigurationManager.ConnectionStrings("DSN_NorthWind").ConnectionString

		' Naten vech zznam z tabulky Employees
		SelectCommand.CommandText = "SELECT top 500 * FROM EMPLOYEES"
		SelectCommand.CommandType = CommandType.Text
		SelectCommand.Connection = DBConSelect

		UpdateCommand.CommandText = _
			" UPDATE EMPLOYEES SET Address=@Address, " + _
			"City=@City, Region=@Region, Country=@Country"

		UpdateCommand.CommandType = CommandType.Text
		UpdateCommand.Connection = DBConUpdate

		Dim AddressParam As SqlParameter
		AddressParam = New SqlParameter("@Address", _
			SqlDbType.VarChar, 15, "Address")

		Dim CityParam As SqlParameter
		CityParam = New SqlParameter("@City", SqlDbType.VarChar, 15, "City")

		Dim RegionParam As SqlParameter
		RegionParam = New SqlParameter("@Region", SqlDbType.VarChar, _
			15, "Region")

		Dim CountryParam As SqlParameter
		CountryParam = New SqlParameter("@Country", _
			SqlDbType.VarChar, 15, "Country")

		UpdateCommand.Parameters.Add(AddressParam)
		UpdateCommand.Parameters.Add(CityParam)
		UpdateCommand.Parameters.Add(RegionParam)
		UpdateCommand.Parameters.Add(CountryParam)

		' Nastaven pkaz Select a Update v objektu DataAdapter.
		' Pkaz Select se pouije k pevzet daj o vech
		' zamstnancch z databze Northwind a pkaz Update
		' se pouije k uloen zmn zpt do tto databze.
		EmpAdapter.SelectCommand = SelectCommand
		EmpAdapter.UpdateCommand = UpdateCommand

		EmpAdapter.Fill(EmpDT)

		DBConSelect.Close()

		' Cyklick prochzen zznamy vech zamstnanc a piazovn
		' novch adres
		For Each DR As DataRow In EmpDT.Rows
			DR("Address") = "4445 W 77th Street, Suite 140"
			DR("City") = "Edina"
			DR("Region") = "Minnesota"
			DR("Country") = "USA"
		Next

		' Pidn novho handleru udlost naslouchajcho udlosti 
		' RowUpdated.
		' Tato udlost se vyvol po vykonn kad dvky.
		AddHandler EmpAdapter.RowUpdated, _
			New SqlRowUpdatedEventHandler(AddressOf OnRowUpdated)

		lblCounter.Text = ""

		EmpAdapter.UpdateBatchSize = 100

		Dim Watch As Diagnostics.Stopwatch = New Diagnostics.Stopwatch()

		' Pi dvkovm zpracovn aktualizovanch zznam je dleit 
		' nastavit tuto vlastnost, protoe dvkov aktualizace nemohou
		' aktualizovat zdroj zmnami z databze.
		UpdateCommand.UpdatedRowSource = UpdateRowSource.None

		Try
			DBConUpdate.Open()
			EmpAdapter.Update(EmpDT)
		Catch ex As Exception
			lblCounter.Text += ex.Message + "<Br>"
		Finally
			If DBConUpdate.State = ConnectionState.Open Then
				DBConUpdate.Close()
			End If
		End Try

	End Sub

	Private Sub OnRowUpdated(ByVal sender As Object, ByVal args As _
		SqlRowUpdatedEventArgs)

		lblCounter.Text += "Dvkov se zpracovalo " + _
			args.RowCount.ToString() + " dk<br>"
	End Sub
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Dvkov zpracovn vce aktualizac</title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<asp:Button ID="btnUpdateAddress" Runat="server" 
			Text="Aktualizovat adresu" OnClick="btnUpdateAddress_Click" />
		<br />
		<br />
		<asp:Label ID="lblCounter" Runat="server"></asp:Label>&nbsp;<br />
		<br />
		<br />
	</div>
	</form>
</body>
</html>
