<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">
	// Deklarace pipojen na tomto mst nm umon pracovat
	// s nm ve vech metodch tto tdy
	SqlConnection DBCon;

	protected void Page_Load(object sender, EventArgs e)
	{
		SqlCommand Command = new SqlCommand();
		SqlDataReader OrdersReader;

		DBCon = new SqlConnection();
		DBCon.ConnectionString =
	ConfigurationManager.ConnectionStrings["DSN_NorthWind"].ConnectionString;

		Command.CommandText =
			" SELECT TOP 5 Customers.CompanyName, Customers.ContactName, " +
			" Orders.OrderID, Orders.OrderDate, " +
			" Orders.RequiredDate, Orders.ShippedDate " +
			" FROM Orders, Customers " +
			" WHERE Orders.CustomerID = Customers.CustomerID " +
			" ORDER BY Customers.CompanyName, Customers.ContactName ";

		Command.CommandType = CommandType.Text;
		Command.Connection = DBCon;

		// Oteven pipojen a vykonn dotazu SQL
		DBCon.Open();
		OrdersReader = Command.ExecuteReader();

		// Vzn objektu DataReader na ovldac prvek GridView
		gvOrders.DataSource = OrdersReader;
		gvOrders.DataBind();

		// Uzaven pipojen po skonen zpracovn vech zznam
		// objednvek
		DBCon.Close();
	}

	protected void gvOrders_RowDataBound(object sender, GridViewRowEventArgs e)
	{
		IDataRecord OrderRecord;
		Label lblOrderDetail;

		// Pevzet aktuln vzanho zznamu z DataReader pomoc
		// rozhran IDataRecord
		OrderRecord = e.Row.DataItem as IDataRecord;

		// Pevzet odkazu na ovldac prvek Label uvnit aktulnho
		// dku prvku GridView. Tento Label bule naplnn Order Details.
		lblOrderDetail = e.Row.FindControl("lblOrderDetail") as Label;

		if ((OrderRecord == null) || (lblOrderDetail == null))
			return;

		SqlCommand Command = new SqlCommand();
		SqlDataReader OrderDetailReader;

		// Vytvoen dotazu SQL pejmn podrobnost aktuln
		// zpracovvan objednvky
		Command.CommandText =
			"SELECT Products.ProductName, [Order Details].UnitPrice, " +
			" [Order Details].Quantity, [Order Details].Discount " +
			" FROM [Order Details], Products " +
			" WHERE [Order Details].ProductID = Products.ProductID " +
			" AND [Order Details].OrderID = " +
			Convert.ToString(OrderRecord["OrderID"]);

		Command.CommandType = CommandType.Text;

		// Opakovan pouit tho objektu pipojen, kter byl
		// pouit k pevzet vech zznam objednvek z tabulky Orders
		Command.Connection = DBCon;

		// Vykonn dotazu SQL bez pedn CommandBehavior.CloseConnection
		// jako parametru ExecuteReader. Nechceme, aby se pipojen 
		// automaticky uzavelo, protoe je potebujeme k dalm operacm.
		OrderDetailReader = Command.ExecuteReader();

		while (OrderDetailReader.Read())
		{
			// Naplnn ovldacho prvku popisku polem nzvu produktu
			lblOrderDetail.Text += OrderDetailReader[0].ToString() + "<Br>";
		}
	}
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Vce aktivnch vsledkovch mnoin</title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<asp:Label ID="lblCounter" Runat="server"></asp:Label>
		<br />
		<asp:GridView ID="gvOrders" Runat="server" AutoGenerateColumns="False"
			OnRowDataBound="gvOrders_RowDataBound" Width="100%">
			<Columns>
				<asp:BoundField HeaderText="Nzev spolenosti"
					DataField="CompanyName"></asp:BoundField>
				<asp:BoundField HeaderText="Jmno kontaktu"
					DataField="ContactName"></asp:BoundField>
				<asp:TemplateField>
					<HeaderTemplate>
						Podrobnosti objednvky
					</HeaderTemplate>
					<ItemTemplate>
						<asp:Label ID="lblOrderDetail" runat="server">
						</asp:Label>
					</ItemTemplate>
				</asp:TemplateField>
				<asp:BoundField HeaderText="Datum objednvky" DataField="orderdate"
					DataFormatString="{0:d}"></asp:BoundField>
				<asp:BoundField HeaderText="Poadovan datum" 
					DataField="requireddate" 
					DataFormatString="{0:d}"></asp:BoundField>
				<asp:BoundField HeaderText="Datum odesln" 
					DataField="shippeddate"
					DataFormatString="{0:d}"></asp:BoundField>
			</Columns>
		</asp:GridView><br />
		<br />
	</div>
	</form>
</body>
</html>
