<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">

	protected void Page_Load(object sender, EventArgs e)
	{
		SqlConnection DBCon;
		SqlCommand Command = new SqlCommand();
		SqlDataReader OrdersReader;
		IAsyncResult ASyncResult;

		DBCon = new SqlConnection();
		DBCon.ConnectionString =
	ConfigurationManager.ConnectionStrings["DSN_NorthWind"].ConnectionString;

		Command.CommandText =
			"SELECT TOP 5 Customers.CompanyName, Customers.ContactName, " +
			" Orders.OrderID, Orders.OrderDate, " +
			" Orders.RequiredDate, Orders.ShippedDate " +
			" FROM Orders, Customers " +
			" WHERE Orders.CustomerID = Customers.CustomerID " +
			" ORDER BY Customers.CompanyName, Customers.ContactName "

		Command.CommandType = CommandType.Text;
		Command.Connection = DBCon;

		DBCon.Open();

		// Sputn asynchronnho zpracovn
		ASyncResult = Command.BeginExecuteReader();

		// Tento cyklus zajist ekn hlavnho vlkna, ne bude
		// asynchronn proces dokonen
		while (!ASyncResult.IsCompleted)
		{
			// Uspn aktulnho vlkna na dobu 10 milisekund
			System.Threading.Thread.Sleep(10);
		}

		// Pevzet vsledku z asynchronnho procesu
		OrdersReader = Command.EndExecuteReader(ASyncResult);

		// Zobrazen vsledku
		gvOrders.DataSource = OrdersReader;
		gvOrders.DataBind();

		// Uzaven pipojen
		DBCon.Close();
	}
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Pstup vyuvajc vzvu</title>
</head>
<body>
	<form id="form1" runat="server">
	<div><br />
		<asp:GridView ID="gvOrders" Runat="server"
			AutoGenerateColumns="False" Width="100%">
			<Columns>
				<asp:BoundField HeaderText="Nzev spolenosti"
					DataField="CompanyName"></asp:BoundField>
				<asp:BoundField HeaderText="Jmno kontaktu"
					DataField="ContactName"></asp:BoundField>
				<asp:BoundField HeaderText="Datum objednvky"
					DataField="orderdate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Datum poadavku" 
					DataField="requireddate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Datum odesln" 
					DataField="shippeddate" DataFormatString="{0:d}">
				</asp:BoundField>
			</Columns>
		</asp:GridView><br />
	</div>
	</form>
</body>
</html>
