<%@ Page Language="VB" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">

	Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs)

		Dim DBCon As SqlConnection
		Dim Command As SqlCommand = New SqlCommand()
		Dim OrdersReader As SqlDataReader
		Dim ASyncResult As IAsyncResult

		DBCon = New SqlConnection()
		DBCon.ConnectionString = _
	ConfigurationManager.ConnectionStrings("DSN_NorthWind").ConnectionString

		Command.CommandText = _
			"SELECT TOP 5 Customers.CompanyName, Customers.ContactName, " & _
			" Orders.OrderID, Orders.OrderDate, " & _
			" Orders.RequiredDate, Orders.ShippedDate " & _
			" FROM Orders, Customers " & _
			" WHERE Orders.CustomerID = Customers.CustomerID " & _
			" ORDER BY Customers.CompanyName, Customers.ContactName "
		Command.CommandType = CommandType.Text

		Command.Connection = DBCon

		DBCon.Open()

		' Sputn asynchronnho zpracovn
		ASyncResult = Command.BeginExecuteReader()

		' Tento cyklus zajist ekn hlavnho vlkna, ne bude
		' asynchronn proces dokonen
		While Not ASyncResult.IsCompleted
			' Uspn aktulnho vlkna na dobu 10 milisekund
			System.Threading.Thread.Sleep(10)
		End While

		' Pevzet vsledku z asynchronnho procesu
		OrdersReader = Command.EndExecuteReader(ASyncResult)

		' Zobrazen vsledku
		gvOrders.DataSource = OrdersReader
		gvOrders.DataBind()

		' Uzaven pipojen
		DBCon.Close()

	End Sub

</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Pstup vyuvajc vzvu</title>
</head>
<body>
	<form id="form1" runat="server">
	<div><br />
		<asp:GridView ID="gvOrders" Runat="server"
			AutoGenerateColumns="False" Width="100%">
			<Columns>
				<asp:BoundField HeaderText="Nzev spolenosti"
					DataField="CompanyName"></asp:BoundField>
				<asp:BoundField HeaderText="Jmno kontaktu"
					DataField="ContactName"></asp:BoundField>
				<asp:BoundField HeaderText="Datum objednvky"
					DataField="orderdate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Datum poadavku" 
					DataField="requireddate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Datum odesln" 
					DataField="shippeddate" DataFormatString="{0:d}">
				</asp:BoundField>
			</Columns>
		</asp:GridView><br />
	</div>
	</form>
</body>
</html>
