<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">
	protected void Page_Load(object sender, EventArgs e)
	{
		SqlConnection DBCon;
		SqlCommand OrdersCommand = new SqlCommand();
		SqlCommand CustCommand = new SqlCommand();
		SqlDataReader OrdersReader;
		SqlDataReader CustReader;
		IAsyncResult OrdersASyncResult;
		IAsyncResult CustAsyncResult;

		int WHIndex;
		System.Threading.WaitHandle[] WHandles =
			new System.Threading.WaitHandle[2];
		System.Threading.WaitHandle OrdersWHandle;
		System.Threading.WaitHandle CustWHandle;

		DBCon = new SqlConnection();
		DBCon.ConnectionString =
	ConfigurationManager.ConnectionStrings["DSN_NorthWind"].ConnectionString;

		CustCommand.CommandText =
	" SELECT * FROM Customers WHERE CompanyName = 'Alfreds Futterkiste' ";

		CustCommand.CommandType = CommandType.Text;
		CustCommand.Connection = DBCon;

		OrdersCommand.CommandText =
			" SELECT Customers.CompanyName, Customers.ContactName, " +
			" Orders.OrderID, Orders.OrderDate, " +
			" Orders.RequiredDate, Orders.ShippedDate " +
			" FROM Orders, Customers " +
			" WHERE Orders.CustomerID = Customers.CustomerID " +
			" AND Customers.CompanyName = 'Alfreds Futterkiste' " +
			" ORDER BY Customers.CompanyName, Customers.ContactName ";

		OrdersCommand.CommandType = CommandType.Text;
		OrdersCommand.Connection = DBCon;

		// Oteven databzovho pipojen
		DBCon.Open();

		// Asynchronn pevzet daj o zkaznkovi
		CustAsyncResult = CustCommand.BeginExecuteReader();

		// Asynchronn pevzet seznamu objednvek
		OrdersASyncResult = OrdersCommand.BeginExecuteReader();

		CustWHandle = CustAsyncResult.AsyncWaitHandle;
		OrdersWHandle = OrdersASyncResult.AsyncWaitHandle;

		// Naplnn pole ekacch manipultor tmi dvma
		// manipultory, kter budeme v kdu pouvat
		WHandles[0] = CustWHandle;
		WHandles[1] = OrdersWHandle;

		// Protoe ekme na dva manipultory v poli, pouvme 
		// dvojit cyklus
		for (int Index = 0; Index < 2; Index++ )
		{
			// ekme jen na to, kdy nkter z naich dvou 
			// asynchronnch proces dobhne
			WHIndex = System.Threading.WaitHandle.WaitAny(WHandles);

			// Nvratovou hodnotou metody WaitAny je index
			// v poli, kter odpovd ekacmu manipultoru,
			// jeho bh skonil
			switch (WHIndex)
			{
				case 0:
					CustReader = CustCommand.EndExecuteReader(CustAsyncResult);

					gvCustomers.DataSource = CustReader;
					gvCustomers.DataBind();
					break;
				case 1:
					OrdersReader =
						OrdersCommand.EndExecuteReader(OrdersASyncResult);

					gvOrders.DataSource = OrdersReader;
					gvOrders.DataBind();
					break;
			}
		}

		// Uzaven pipojen
		DBCon.Close();
	}
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Pstup vyuvajc ekn na nkter proces</title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<asp:GridView ID="gvCustomers" Width="100%" Runat="server">
		</asp:GridView>
		<br /><br />
		<asp:GridView ID="gvOrders" Width="100%" AutoGenerateColumns="False"
			Runat="server">
			<Columns>
				<asp:BoundField HeaderText="Nzev spolenosti"
					DataField="CompanyName"></asp:BoundField>
				<asp:BoundField HeaderText="Jmno kontaktu"
					DataField="ContactName"></asp:BoundField>
				<asp:BoundField HeaderText="Datum objednvky"
					DataField="orderdate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Poadovan datum" 
					DataField="requireddate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Datum odesln" 
					DataField="shippeddate" DataFormatString="{0:d}">
				</asp:BoundField>
			</Columns>
		</asp:GridView>
	</div>
	</form>
</body>
</html>
