<%@ Page Language="C#" %>
<%@ Import Namespace="System.Data" %>
<%@ Import Namespace="System.Data.SqlClient" %>
<%@ Import Namespace="System.Configuration" %>

<script runat="server">
	protected void Page_Load(object sender, EventArgs e)
	{
		SqlConnection DBCon;
		SqlCommand Command = new SqlCommand();
		SqlAsyncResult ASyncResult;

		DBCon = new SqlConnection();
		Command = new SqlCommand();

		DBCon.ConnectionString =
	ConfigurationManager.ConnectionStrings["DSN_NorthWind"].ConnectionString;

		// Vbr prvnch pti zznam z tabulky Orders
		Command.CommandText =
			"SELECT TOP 5 Customers.CompanyName, Customers.ContactName, " +
			" Orders.OrderID, Orders.OrderDate, " +
			" Orders.RequiredDate, Orders.ShippedDate " +
			" FROM Orders, Customers " +
			" WHERE Orders.CustomerID = Customers.CustomerID " +
			" ORDER BY Customers.CompanyName, Customers.ContactName ";

		Command.CommandType = CommandType.Text;
		Command.Connection = DBCon;

		DBCon.Open();

		// Sputn asynchronnho zpracovn
		AsyncResult = Command.BeginExecuteReader(new AsyncCallback(CBMethod),
			CommandBehavior.CloseConnection);
	}

	public void CBMethod(SQLAsyncResult ar)
	{
		SqlDataReader OrdersReader;

		// Pevzet vsledku od asynchronnho procesu
		OrdersReader = ar.EndExecuteReader(ar);

		// Zobrazen vsledku na obrazovce
		gvOrders.DataSource = OrdersReader;
		gvOrders.DataBind();
	}
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Vyuit zptnho voln</title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<asp:GridView ID="gvOrders" Width="100%" AutoGenerateColumns="False"
			Runat="server">
			<Columns>
				<asp:BoundField HeaderText="Nzev spolenosti"
					DataField="CompanyName"></asp:BoundField>
				<asp:BoundField HeaderText="Jmno kontaktu"
					DataField="ContactName"></asp:BoundField>
				<asp:BoundField HeaderText="Datum objednvky"
					DataField="orderdate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Poadovan datum" 
					DataField="requireddate" DataFormatString="{0:d}">
				</asp:BoundField>
				<asp:BoundField HeaderText="Datum odesln" 
					DataField="shippeddate" DataFormatString="{0:d}">
				</asp:BoundField>
			</Columns>
		</asp:GridView>
	</div>
	</form>
</body>
</html>
