<%@ Page Language="C#" %>

<script runat="server">
	protected void Page_Load(object sender, EventArgs e)
	{
		foreach (System.IO.DriveInfo drive in System.IO.DriveInfo.GetDrives())
		{
			TreeNode node = new TreeNode();
			node.Value = drive.Name;

			if (drive.IsReady)
			{
				node.Text = drive.Name +
					" - (voln prostor: " + drive.AvailableFreeSpace + ")";
				LoadDirectories(node, drive.Name);
			}
			else
				node.Text = drive.Name + " - (nepipraven)";

			this.TreeView1.Nodes.Add(node);
		}
		this.TreeView1.CollapseAll();
	}

	private void LoadDirectories(TreeNode parent, string path)
	{
		System.IO.DirectoryInfo directory = new System.IO.DirectoryInfo(path);

		try
		{
			foreach (System.IO.DirectoryInfo d in directory.GetDirectories())
			{
				TreeNode node = new TreeNode(d.Name, d.FullName);
				parent.ChildNodes.Add(node);

				// Rekurzivn prochzet aktulnm adresem
				LoadDirectories(node, d.FullName);
			}
		}
		catch (System.UnauthorizedAccessException e)
		{
			parent.Text += " (pstup byl odepen)";
		}
		catch (System.IO.IOException e)
		{
			parent.Text += " (neznm chyba: " + e.Message + ")";
		}
	}
</script>

<html xmlns="http://www.w3.org/1999/xhtml" >
<head id="Head1" runat="server">
	<title>Prochzen jednotkami loklnho souborovho systmu</title>
</head>
<body>
	<form id="form1" runat="server">
	<div>
		<table>
			<tr>
				<td style="width: 100px" valign="top">
					<asp:TreeView ID="TreeView1" runat="server"></asp:TreeView>
				</td>
			</tr>
		</table>
	</div>
	</form>
</body>
</html>
