using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.IO;
using System.IO.Compression;

namespace ClassLibrary1
{
    public class Class1 : IHttpModule
    {
        #region IHttpModule Members

        void IHttpModule.Dispose()
        {
            throw new Exception("Tato metoda nebo operace nen implementovna.");
        }

        void IHttpModule.Init(HttpApplication context)
        {
            context.BeginRequest += new EventHandler(context_BeginRequest);
        }

        void context_BeginRequest(object sender, EventArgs e)
        {
            HttpApplication app = (HttpApplication)sender;
            // Pevzt hlaviku Accept-Encoding protokolu HTTP z poadavku.
            // Poadujc prohle odesl tuto hlaviku, kterou pouijeme
            // k uren, zda podporuje kompresi, a pokud ano, tak o jak typ
            // kompresnmo algoritmu se jedn.
            string encodings = app.Request.Headers.Get("Accept-Encoding");

            if (encodings == null)
                return;

            Stream s = app.Response.Filter;

            encodings = encodings.ToLower();

            if (encodings.Contains("gzip"))
            {
                app.Response.Filter = 
                    new GZipStream(s, CompressionMode.Compress);
                app.Response.AppendHeader("Content-Encoding", "gzip");
                app.Context.Trace.Warn("Zapnuta komprese GZIP");
            }
            else
            {
                app.Response.Filter =
                    new DeflateStream(s, CompressionMode.Compress);
                app.Response.AppendHeader("Content-Encoding", "deflate");
                app.Context.Trace.Warn("Zapnuta komprese Deflate");
            }
        }
        #endregion
    }
}
